require "greentext/client"

# Public: The main Greentext module.
module Greentext
  class << self
    # Public: An instance of the client when calling methods
    #   on the Greentext module.
    #
    #   Returns an Instance of Greentext::Client
    def client
      @client ||= Greentext::Client.new
    end

    def respond_to?(method_name, include_private=false)
      client.respond_to?(method_name, include_private) || super
    end

    private

    def method_missing(method_name, *args, &block)
      if client.respond_to?(method_name)
        client.send(method_name, *args, &block)
      else
        super
      end
    end
  end
end
