require "greentext/post"

module Greentext
  class Client
    # Internal: Methods for interacting with posts
    module Post
      # Public: Get the expanded threads given a Greentext::Post object.
      #   This will only work if the post is OP.
      #
      # post - a Greentext::Post object.
      #
      # Returns an Array of Greentext::Post instances.
      def expand(post)
        if post.op?
          posts = get("/#{post.board.name}/res/#{post.no}.json")["posts"]
          posts.map do |params|
            params.merge!("board" => post.board)
            Greentext::Post.new(params)
          end
        else
          fail ArgumentError, "This is not the first post in the thread."
        end
      end
    end
  end
end
